Index: trunk/lib/Text/FormBuilder/Parser.pm
===================================================================
--- trunk/lib/Text/FormBuilder/Parser.pm	(revision 1)
+++ trunk/lib/Text/FormBuilder/Parser.pm	(revision 10)
@@ -569,5 +569,5 @@
 	{
 		
-		Parse::RecDescent::_trace(q{Trying production: ['!list' list_name '\{' <leftop: option /,\\s*/ option> /,?/ '\}']},
+		Parse::RecDescent::_trace(q{Trying production: ['!list' list_name static_list, or dynamic_list]},
 					  Parse::RecDescent::_tracefirst($_[1]),
 					  q{list_def},
@@ -637,55 +637,15 @@
 		}
 
-		Parse::RecDescent::_trace(q{Trying terminal: ['\{']},
-					  Parse::RecDescent::_tracefirst($text),
-					  q{list_def},
-					  $tracelevel)
-						if defined $::RD_TRACE;
-		$lastsep = "";
-		$expectation->is(q{'\{'})->at($text);
-		
-
-		unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ s/\A\{//)
-		{
-			
-			$expectation->failed();
-			Parse::RecDescent::_trace(qq{<<Didn't match terminal>>},
-						  Parse::RecDescent::_tracefirst($text))
-							if defined $::RD_TRACE;
-			last;
-		}
-		Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
-						. $& . q{])},
-						  Parse::RecDescent::_tracefirst($text))
-							if defined $::RD_TRACE;
-		push @item, $item{__STRING2__}=$&;
-		
-
-		Parse::RecDescent::_trace(q{Trying operator: [<leftop: option /,\\s*/ option>]},
+		Parse::RecDescent::_trace(q{Trying subrule: [_alternation_1_of_production_1_of_rule_list_def]},
 				  Parse::RecDescent::_tracefirst($text),
 				  q{list_def},
 				  $tracelevel)
 					if defined $::RD_TRACE;
-		$expectation->is(q{<leftop: option /,\\s*/ option>})->at($text);
-
-		$_tok = undef;
-		OPLOOP: while (1)
-		{
-		  $repcount = 0;
-		  my  @item;
-		  
-		  # MATCH LEFTARG
-		  
-		Parse::RecDescent::_trace(q{Trying subrule: [option]},
-				  Parse::RecDescent::_tracefirst($text),
-				  q{list_def},
-				  $tracelevel)
-					if defined $::RD_TRACE;
 		if (1) { no strict qw{refs};
-		$expectation->is(q{option})->at($text);
-		unless (defined ($_tok = Parse::RecDescent::Text::FormBuilder::Parser::option($thisparser,$text,$repeating,$_noactions,sub { \@arg })))
+		$expectation->is(q{static_list, or dynamic_list})->at($text);
+		unless (defined ($_tok = Parse::RecDescent::Text::FormBuilder::Parser::_alternation_1_of_production_1_of_rule_list_def($thisparser,$text,$repeating,$_noactions,sub { \@arg })))
 		{
 			
-			Parse::RecDescent::_trace(q{<<Didn't match subrule: [option]>>},
+			Parse::RecDescent::_trace(q{<<Didn't match subrule: [_alternation_1_of_production_1_of_rule_list_def]>>},
 						  Parse::RecDescent::_tracefirst($text),
 						  q{list_def},
@@ -695,5 +655,5 @@
 			last;
 		}
-		Parse::RecDescent::_trace(q{>>Matched subrule: [option]<< (return value: [}
+		Parse::RecDescent::_trace(q{>>Matched subrule: [_alternation_1_of_production_1_of_rule_list_def]<< (return value: [}
 					. $_tok . q{]},
 					  
@@ -702,158 +662,8 @@
 					  $tracelevel)
 						if defined $::RD_TRACE;
-		$item{q{option}} = $_tok;
+		$item{q{_alternation_1_of_production_1_of_rule_list_def}} = $_tok;
 		push @item, $_tok;
 		
 		}
-
-
-		  $repcount++;
-
-		  my $savetext = $text;
-		  my $backtrack;
-
-		  # MATCH (OP RIGHTARG)(s)
-		  while ($repcount < 100000000)
-		  {
-			$backtrack = 0;
-			
-		Parse::RecDescent::_trace(q{Trying terminal: [/,\\s*/]}, Parse::RecDescent::_tracefirst($text),
-					  q{list_def},
-					  $tracelevel)
-						if defined $::RD_TRACE;
-		$lastsep = "";
-		$expectation->is(q{/,\\s*/})->at($text);
-		
-
-		unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ s/\A(?:,\s*)//)
-		{
-			
-			$expectation->failed();
-			Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
-						  Parse::RecDescent::_tracefirst($text))
-					if defined $::RD_TRACE;
-
-			last;
-		}
-		Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
-						. $& . q{])},
-						  Parse::RecDescent::_tracefirst($text))
-					if defined $::RD_TRACE;
-		push @item, $item{__PATTERN1__}=$&;
-		
-
-			pop @item;
-			if (defined $1) {push @item, $item{'option(s)'}=$1; $backtrack=1;}
-			
-		Parse::RecDescent::_trace(q{Trying subrule: [option]},
-				  Parse::RecDescent::_tracefirst($text),
-				  q{list_def},
-				  $tracelevel)
-					if defined $::RD_TRACE;
-		if (1) { no strict qw{refs};
-		$expectation->is(q{option})->at($text);
-		unless (defined ($_tok = Parse::RecDescent::Text::FormBuilder::Parser::option($thisparser,$text,$repeating,$_noactions,sub { \@arg })))
-		{
-			
-			Parse::RecDescent::_trace(q{<<Didn't match subrule: [option]>>},
-						  Parse::RecDescent::_tracefirst($text),
-						  q{list_def},
-						  $tracelevel)
-							if defined $::RD_TRACE;
-			$expectation->failed();
-			last;
-		}
-		Parse::RecDescent::_trace(q{>>Matched subrule: [option]<< (return value: [}
-					. $_tok . q{]},
-					  
-					  Parse::RecDescent::_tracefirst($text),
-					  q{list_def},
-					  $tracelevel)
-						if defined $::RD_TRACE;
-		$item{q{option}} = $_tok;
-		push @item, $_tok;
-		
-		}
-
-			$savetext = $text;
-			$repcount++;
-		  }
-		  $text = $savetext;
-		  pop @item if $backtrack;
-
-		  unless (@item) { undef $_tok; last }
-		  $_tok = [ @item ];
-		  last;
-		} 
-
-		unless ($repcount>=1)
-		{
-			Parse::RecDescent::_trace(q{<<Didn't match operator: [<leftop: option /,\\s*/ option>]>>},
-						  Parse::RecDescent::_tracefirst($text),
-						  q{list_def},
-						  $tracelevel)
-							if defined $::RD_TRACE;
-			$expectation->failed();
-			last;
-		}
-		Parse::RecDescent::_trace(q{>>Matched operator: [<leftop: option /,\\s*/ option>]<< (return value: [}
-					  . qq{@{$_tok||[]}} . q{]},
-					  Parse::RecDescent::_tracefirst($text),
-					  q{list_def},
-					  $tracelevel)
-						if defined $::RD_TRACE;
-
-		push @item, $item{'option(s)'}=$_tok||[];
-
-
-		Parse::RecDescent::_trace(q{Trying terminal: [/,?/]}, Parse::RecDescent::_tracefirst($text),
-					  q{list_def},
-					  $tracelevel)
-						if defined $::RD_TRACE;
-		$lastsep = "";
-		$expectation->is(q{/,?/})->at($text);
-		
-
-		unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ s/\A(?:,?)//)
-		{
-			
-			$expectation->failed();
-			Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
-						  Parse::RecDescent::_tracefirst($text))
-					if defined $::RD_TRACE;
-
-			last;
-		}
-		Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
-						. $& . q{])},
-						  Parse::RecDescent::_tracefirst($text))
-					if defined $::RD_TRACE;
-		push @item, $item{__PATTERN2__}=$&;
-		
-
-		Parse::RecDescent::_trace(q{Trying terminal: ['\}']},
-					  Parse::RecDescent::_tracefirst($text),
-					  q{list_def},
-					  $tracelevel)
-						if defined $::RD_TRACE;
-		$lastsep = "";
-		$expectation->is(q{'\}'})->at($text);
-		
-
-		unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ s/\A\}//)
-		{
-			
-			$expectation->failed();
-			Parse::RecDescent::_trace(qq{<<Didn't match terminal>>},
-						  Parse::RecDescent::_tracefirst($text))
-							if defined $::RD_TRACE;
-			last;
-		}
-		Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
-						. $& . q{])},
-						  Parse::RecDescent::_tracefirst($text))
-							if defined $::RD_TRACE;
-		push @item, $item{__STRING3__}=$&;
-		
 
 		Parse::RecDescent::_trace(q{Trying action},
@@ -880,5 +690,5 @@
 
 
-		Parse::RecDescent::_trace(q{>>Matched production: ['!list' list_name '\{' <leftop: option /,\\s*/ option> /,?/ '\}']<<},
+		Parse::RecDescent::_trace(q{>>Matched production: ['!list' list_name static_list, or dynamic_list]<<},
 					  Parse::RecDescent::_tracefirst($text),
 					  q{list_def},
@@ -4626,5 +4436,5 @@
 
 # ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args)
-sub Parse::RecDescent::Text::FormBuilder::Parser::form_spec
+sub Parse::RecDescent::Text::FormBuilder::Parser::_alternation_1_of_production_1_of_rule_list_def
 {
 	my $thisparser = $_[0];
@@ -4632,9 +4442,9 @@
 	local $tracelevel = ($tracelevel||0)+1;
 	$ERRORS = 0;
-	my $thisrule = $thisparser->{"rules"}{"form_spec"};
-	
-	Parse::RecDescent::_trace(q{Trying rule: [form_spec]},
+	my $thisrule = $thisparser->{"rules"}{"_alternation_1_of_production_1_of_rule_list_def"};
+	
+	Parse::RecDescent::_trace(q{Trying rule: [_alternation_1_of_production_1_of_rule_list_def]},
 				  Parse::RecDescent::_tracefirst($_[1]),
-				  q{form_spec},
+				  q{_alternation_1_of_production_1_of_rule_list_def},
 				  $tracelevel)
 					if defined $::RD_TRACE;
@@ -4668,7 +4478,7 @@
 	{
 		
-		Parse::RecDescent::_trace(q{Trying production: [list_def, or line]},
+		Parse::RecDescent::_trace(q{Trying production: [static_list]},
 					  Parse::RecDescent::_tracefirst($_[1]),
-					  q{form_spec},
+					  q{_alternation_1_of_production_1_of_rule_list_def},
 					  $tracelevel)
 						if defined $::RD_TRACE;
@@ -4676,71 +4486,100 @@
 		$text = $_[1];
 		my $_savetext;
-		@item = (q{form_spec});
-		%item = (__RULE__ => q{form_spec});
+		@item = (q{_alternation_1_of_production_1_of_rule_list_def});
+		%item = (__RULE__ => q{_alternation_1_of_production_1_of_rule_list_def});
 		my $repcount = 0;
 
 
-		Parse::RecDescent::_trace(q{Trying repeated subrule: [list_def, or line]},
+		Parse::RecDescent::_trace(q{Trying subrule: [static_list]},
 				  Parse::RecDescent::_tracefirst($text),
-				  q{form_spec},
+				  q{_alternation_1_of_production_1_of_rule_list_def},
 				  $tracelevel)
 					if defined $::RD_TRACE;
+		if (1) { no strict qw{refs};
 		$expectation->is(q{})->at($text);
-		
-		unless (defined ($_tok = $thisparser->_parserepeat($text, \&Parse::RecDescent::Text::FormBuilder::Parser::_alternation_1_of_production_1_of_rule_form_spec, 1, 100000000, $_noactions,$expectation,undef))) 
-		{
-			Parse::RecDescent::_trace(q{<<Didn't match repeated subrule: [list_def, or line]>>},
+		unless (defined ($_tok = Parse::RecDescent::Text::FormBuilder::Parser::static_list($thisparser,$text,$repeating,$_noactions,sub { \@arg })))
+		{
+			
+			Parse::RecDescent::_trace(q{<<Didn't match subrule: [static_list]>>},
 						  Parse::RecDescent::_tracefirst($text),
-						  q{form_spec},
+						  q{_alternation_1_of_production_1_of_rule_list_def},
 						  $tracelevel)
 							if defined $::RD_TRACE;
-			last;
-		}
-		Parse::RecDescent::_trace(q{>>Matched repeated subrule: [_alternation_1_of_production_1_of_rule_form_spec]<< (}
-					. @$_tok . q{ times)},
+			$expectation->failed();
+			last;
+		}
+		Parse::RecDescent::_trace(q{>>Matched subrule: [static_list]<< (return value: [}
+					. $_tok . q{]},
 					  
 					  Parse::RecDescent::_tracefirst($text),
-					  q{form_spec},
-					  $tracelevel)
-						if defined $::RD_TRACE;
-		$item{q{_alternation_1_of_production_1_of_rule_form_spec(s)}} = $_tok;
+					  q{_alternation_1_of_production_1_of_rule_list_def},
+					  $tracelevel)
+						if defined $::RD_TRACE;
+		$item{q{static_list}} = $_tok;
 		push @item, $_tok;
 		
-
-
-		Parse::RecDescent::_trace(q{Trying action},
-					  Parse::RecDescent::_tracefirst($text),
-					  q{form_spec},
-					  $tracelevel)
-						if defined $::RD_TRACE;
-		
-
-		$_tok = ($_noactions) ? 0 : do {
-	$return = {
-	    title    => $title,
-	    author   => $author,
-	    lists    => \%lists, 
-	    patterns => \%patterns, 
-	    fields   => \@fields,
-	}
-    };
-		unless (defined $_tok)
-		{
-			Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
-					if defined $::RD_TRACE;
-			last;
-		}
-		Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
-					  . $_tok . q{])},
-					  Parse::RecDescent::_tracefirst($text))
-						if defined $::RD_TRACE;
+		}
+
+
+		Parse::RecDescent::_trace(q{>>Matched production: [static_list]<<},
+					  Parse::RecDescent::_tracefirst($text),
+					  q{_alternation_1_of_production_1_of_rule_list_def},
+					  $tracelevel)
+						if defined $::RD_TRACE;
+		$_matched = 1;
+		last;
+	}
+
+
+	while (!$_matched && !$commit)
+	{
+		
+		Parse::RecDescent::_trace(q{Trying production: [dynamic_list]},
+					  Parse::RecDescent::_tracefirst($_[1]),
+					  q{_alternation_1_of_production_1_of_rule_list_def},
+					  $tracelevel)
+						if defined $::RD_TRACE;
+		my $thisprod = $thisrule->{"prods"}[1];
+		$text = $_[1];
+		my $_savetext;
+		@item = (q{_alternation_1_of_production_1_of_rule_list_def});
+		%item = (__RULE__ => q{_alternation_1_of_production_1_of_rule_list_def});
+		my $repcount = 0;
+
+
+		Parse::RecDescent::_trace(q{Trying subrule: [dynamic_list]},
+				  Parse::RecDescent::_tracefirst($text),
+				  q{_alternation_1_of_production_1_of_rule_list_def},
+				  $tracelevel)
+					if defined $::RD_TRACE;
+		if (1) { no strict qw{refs};
+		$expectation->is(q{})->at($text);
+		unless (defined ($_tok = Parse::RecDescent::Text::FormBuilder::Parser::dynamic_list($thisparser,$text,$repeating,$_noactions,sub { \@arg })))
+		{
+			
+			Parse::RecDescent::_trace(q{<<Didn't match subrule: [dynamic_list]>>},
+						  Parse::RecDescent::_tracefirst($text),
+						  q{_alternation_1_of_production_1_of_rule_list_def},
+						  $tracelevel)
+							if defined $::RD_TRACE;
+			$expectation->failed();
+			last;
+		}
+		Parse::RecDescent::_trace(q{>>Matched subrule: [dynamic_list]<< (return value: [}
+					. $_tok . q{]},
+					  
+					  Parse::RecDescent::_tracefirst($text),
+					  q{_alternation_1_of_production_1_of_rule_list_def},
+					  $tracelevel)
+						if defined $::RD_TRACE;
+		$item{q{dynamic_list}} = $_tok;
 		push @item, $_tok;
-		$item{__ACTION1__}=$_tok;
-		
-
-
-		Parse::RecDescent::_trace(q{>>Matched production: [list_def, or line]<<},
-					  Parse::RecDescent::_tracefirst($text),
-					  q{form_spec},
+		
+		}
+
+
+		Parse::RecDescent::_trace(q{>>Matched production: [dynamic_list]<<},
+					  Parse::RecDescent::_tracefirst($text),
+					  q{_alternation_1_of_production_1_of_rule_list_def},
 					  $tracelevel)
 						if defined $::RD_TRACE;
@@ -4757,5 +4596,5 @@
 		Parse::RecDescent::_trace(q{<<Didn't match rule>>},
 					 Parse::RecDescent::_tracefirst($_[1]),
-					 q{form_spec},
+					 q{_alternation_1_of_production_1_of_rule_list_def},
 					 $tracelevel)
 					if defined $::RD_TRACE;
@@ -4765,5 +4604,5 @@
 	{
 		Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
-					  q{form_spec},
+					  q{_alternation_1_of_production_1_of_rule_list_def},
 					  $tracelevel)
 						if defined $::RD_TRACE;
@@ -4776,10 +4615,10 @@
 		Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
 					  $return . q{])}, "",
-					  q{form_spec},
+					  q{_alternation_1_of_production_1_of_rule_list_def},
 					  $tracelevel);
 		Parse::RecDescent::_trace(q{(consumed: [} .
 					  Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])}, 
 					  Parse::RecDescent::_tracefirst($text),
-					  , q{form_spec},
+					  , q{_alternation_1_of_production_1_of_rule_list_def},
 					  $tracelevel)
 	}
@@ -4789,5 +4628,5 @@
 
 # ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args)
-sub Parse::RecDescent::Text::FormBuilder::Parser::pattern
+sub Parse::RecDescent::Text::FormBuilder::Parser::form_spec
 {
 	my $thisparser = $_[0];
@@ -4795,9 +4634,9 @@
 	local $tracelevel = ($tracelevel||0)+1;
 	$ERRORS = 0;
-	my $thisrule = $thisparser->{"rules"}{"pattern"};
-	
-	Parse::RecDescent::_trace(q{Trying rule: [pattern]},
+	my $thisrule = $thisparser->{"rules"}{"form_spec"};
+	
+	Parse::RecDescent::_trace(q{Trying rule: [form_spec]},
 				  Parse::RecDescent::_tracefirst($_[1]),
-				  q{pattern},
+				  q{form_spec},
 				  $tracelevel)
 					if defined $::RD_TRACE;
@@ -4831,7 +4670,7 @@
 	{
 		
-		Parse::RecDescent::_trace(q{Trying production: [/.*/]},
+		Parse::RecDescent::_trace(q{Trying production: [list_def, or line]},
 					  Parse::RecDescent::_tracefirst($_[1]),
-					  q{pattern},
+					  q{form_spec},
 					  $tracelevel)
 						if defined $::RD_TRACE;
@@ -4839,38 +4678,71 @@
 		$text = $_[1];
 		my $_savetext;
-		@item = (q{pattern});
-		%item = (__RULE__ => q{pattern});
+		@item = (q{form_spec});
+		%item = (__RULE__ => q{form_spec});
 		my $repcount = 0;
 
 
-		Parse::RecDescent::_trace(q{Trying terminal: [/.*/]}, Parse::RecDescent::_tracefirst($text),
-					  q{pattern},
-					  $tracelevel)
-						if defined $::RD_TRACE;
-		$lastsep = "";
+		Parse::RecDescent::_trace(q{Trying repeated subrule: [list_def, or line]},
+				  Parse::RecDescent::_tracefirst($text),
+				  q{form_spec},
+				  $tracelevel)
+					if defined $::RD_TRACE;
 		$expectation->is(q{})->at($text);
 		
-
-		unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ s/\A(?:.*)//)
-		{
-			
-			$expectation->failed();
-			Parse::RecDescent::_trace(q{<<Didn't match terminal>>},
-						  Parse::RecDescent::_tracefirst($text))
-					if defined $::RD_TRACE;
-
-			last;
-		}
-		Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
-						. $& . q{])},
-						  Parse::RecDescent::_tracefirst($text))
-					if defined $::RD_TRACE;
-		push @item, $item{__PATTERN1__}=$&;
-		
-
-
-		Parse::RecDescent::_trace(q{>>Matched production: [/.*/]<<},
-					  Parse::RecDescent::_tracefirst($text),
-					  q{pattern},
+		unless (defined ($_tok = $thisparser->_parserepeat($text, \&Parse::RecDescent::Text::FormBuilder::Parser::_alternation_1_of_production_1_of_rule_form_spec, 1, 100000000, $_noactions,$expectation,undef))) 
+		{
+			Parse::RecDescent::_trace(q{<<Didn't match repeated subrule: [list_def, or line]>>},
+						  Parse::RecDescent::_tracefirst($text),
+						  q{form_spec},
+						  $tracelevel)
+							if defined $::RD_TRACE;
+			last;
+		}
+		Parse::RecDescent::_trace(q{>>Matched repeated subrule: [_alternation_1_of_production_1_of_rule_form_spec]<< (}
+					. @$_tok . q{ times)},
+					  
+					  Parse::RecDescent::_tracefirst($text),
+					  q{form_spec},
+					  $tracelevel)
+						if defined $::RD_TRACE;
+		$item{q{_alternation_1_of_production_1_of_rule_form_spec(s)}} = $_tok;
+		push @item, $_tok;
+		
+
+
+		Parse::RecDescent::_trace(q{Trying action},
+					  Parse::RecDescent::_tracefirst($text),
+					  q{form_spec},
+					  $tracelevel)
+						if defined $::RD_TRACE;
+		
+
+		$_tok = ($_noactions) ? 0 : do {
+	$return = {
+	    title    => $title,
+	    author   => $author,
+	    lists    => \%lists, 
+	    patterns => \%patterns, 
+	    fields   => \@fields,
+	}
+    };
+		unless (defined $_tok)
+		{
+			Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
+					if defined $::RD_TRACE;
+			last;
+		}
+		Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
+					  . $_tok . q{])},
+					  Parse::RecDescent::_tracefirst($text))
+						if defined $::RD_TRACE;
+		push @item, $_tok;
+		$item{__ACTION1__}=$_tok;
+		
+
+
+		Parse::RecDescent::_trace(q{>>Matched production: [list_def, or line]<<},
+					  Parse::RecDescent::_tracefirst($text),
+					  q{form_spec},
 					  $tracelevel)
 						if defined $::RD_TRACE;
@@ -4887,5 +4759,5 @@
 		Parse::RecDescent::_trace(q{<<Didn't match rule>>},
 					 Parse::RecDescent::_tracefirst($_[1]),
-					 q{pattern},
+					 q{form_spec},
 					 $tracelevel)
 					if defined $::RD_TRACE;
@@ -4895,5 +4767,5 @@
 	{
 		Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
-					  q{pattern},
+					  q{form_spec},
 					  $tracelevel)
 						if defined $::RD_TRACE;
@@ -4906,10 +4778,10 @@
 		Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
 					  $return . q{])}, "",
-					  q{pattern},
+					  q{form_spec},
 					  $tracelevel);
 		Parse::RecDescent::_trace(q{(consumed: [} .
 					  Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])}, 
 					  Parse::RecDescent::_tracefirst($text),
-					  , q{pattern},
+					  , q{form_spec},
 					  $tracelevel)
 	}
@@ -4919,5 +4791,5 @@
 
 # ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args)
-sub Parse::RecDescent::Text::FormBuilder::Parser::comment
+sub Parse::RecDescent::Text::FormBuilder::Parser::pattern
 {
 	my $thisparser = $_[0];
@@ -4925,9 +4797,9 @@
 	local $tracelevel = ($tracelevel||0)+1;
 	$ERRORS = 0;
-	my $thisrule = $thisparser->{"rules"}{"comment"};
-	
-	Parse::RecDescent::_trace(q{Trying rule: [comment]},
+	my $thisrule = $thisparser->{"rules"}{"pattern"};
+	
+	Parse::RecDescent::_trace(q{Trying rule: [pattern]},
 				  Parse::RecDescent::_tracefirst($_[1]),
-				  q{comment},
+				  q{pattern},
 				  $tracelevel)
 					if defined $::RD_TRACE;
@@ -4961,7 +4833,7 @@
 	{
 		
-		Parse::RecDescent::_trace(q{Trying production: ['#' /.*/]},
+		Parse::RecDescent::_trace(q{Trying production: [/.*/]},
 					  Parse::RecDescent::_tracefirst($_[1]),
-					  q{comment},
+					  q{pattern},
 					  $tracelevel)
 						if defined $::RD_TRACE;
@@ -4969,40 +4841,15 @@
 		$text = $_[1];
 		my $_savetext;
-		@item = (q{comment});
-		%item = (__RULE__ => q{comment});
+		@item = (q{pattern});
+		%item = (__RULE__ => q{pattern});
 		my $repcount = 0;
 
 
-		Parse::RecDescent::_trace(q{Trying terminal: ['#']},
-					  Parse::RecDescent::_tracefirst($text),
-					  q{comment},
+		Parse::RecDescent::_trace(q{Trying terminal: [/.*/]}, Parse::RecDescent::_tracefirst($text),
+					  q{pattern},
 					  $tracelevel)
 						if defined $::RD_TRACE;
 		$lastsep = "";
 		$expectation->is(q{})->at($text);
-		
-
-		unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ s/\A\#//)
-		{
-			
-			$expectation->failed();
-			Parse::RecDescent::_trace(qq{<<Didn't match terminal>>},
-						  Parse::RecDescent::_tracefirst($text))
-							if defined $::RD_TRACE;
-			last;
-		}
-		Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
-						. $& . q{])},
-						  Parse::RecDescent::_tracefirst($text))
-							if defined $::RD_TRACE;
-		push @item, $item{__STRING1__}=$&;
-		
-
-		Parse::RecDescent::_trace(q{Trying terminal: [/.*/]}, Parse::RecDescent::_tracefirst($text),
-					  q{comment},
-					  $tracelevel)
-						if defined $::RD_TRACE;
-		$lastsep = "";
-		$expectation->is(q{/.*/})->at($text);
 		
 
@@ -5025,7 +4872,7 @@
 
 
-		Parse::RecDescent::_trace(q{>>Matched production: ['#' /.*/]<<},
-					  Parse::RecDescent::_tracefirst($text),
-					  q{comment},
+		Parse::RecDescent::_trace(q{>>Matched production: [/.*/]<<},
+					  Parse::RecDescent::_tracefirst($text),
+					  q{pattern},
 					  $tracelevel)
 						if defined $::RD_TRACE;
@@ -5042,5 +4889,5 @@
 		Parse::RecDescent::_trace(q{<<Didn't match rule>>},
 					 Parse::RecDescent::_tracefirst($_[1]),
-					 q{comment},
+					 q{pattern},
 					 $tracelevel)
 					if defined $::RD_TRACE;
@@ -5050,5 +4897,5 @@
 	{
 		Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
-					  q{comment},
+					  q{pattern},
 					  $tracelevel)
 						if defined $::RD_TRACE;
@@ -5061,10 +4908,10 @@
 		Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
 					  $return . q{])}, "",
-					  q{comment},
+					  q{pattern},
 					  $tracelevel);
 		Parse::RecDescent::_trace(q{(consumed: [} .
 					  Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])}, 
 					  Parse::RecDescent::_tracefirst($text),
-					  , q{comment},
+					  , q{pattern},
 					  $tracelevel)
 	}
@@ -5074,5 +4921,5 @@
 
 # ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args)
-sub Parse::RecDescent::Text::FormBuilder::Parser::hint
+sub Parse::RecDescent::Text::FormBuilder::Parser::comment
 {
 	my $thisparser = $_[0];
@@ -5080,9 +4927,9 @@
 	local $tracelevel = ($tracelevel||0)+1;
 	$ERRORS = 0;
-	my $thisrule = $thisparser->{"rules"}{"hint"};
-	
-	Parse::RecDescent::_trace(q{Trying rule: [hint]},
+	my $thisrule = $thisparser->{"rules"}{"comment"};
+	
+	Parse::RecDescent::_trace(q{Trying rule: [comment]},
 				  Parse::RecDescent::_tracefirst($_[1]),
-				  q{hint},
+				  q{comment},
 				  $tracelevel)
 					if defined $::RD_TRACE;
@@ -5116,7 +4963,7 @@
 	{
 		
-		Parse::RecDescent::_trace(q{Trying production: ['[' /[^\\]]+/ ']']},
+		Parse::RecDescent::_trace(q{Trying production: ['#' /.*/]},
 					  Parse::RecDescent::_tracefirst($_[1]),
-					  q{hint},
+					  q{comment},
 					  $tracelevel)
 						if defined $::RD_TRACE;
@@ -5124,12 +4971,12 @@
 		$text = $_[1];
 		my $_savetext;
-		@item = (q{hint});
-		%item = (__RULE__ => q{hint});
+		@item = (q{comment});
+		%item = (__RULE__ => q{comment});
 		my $repcount = 0;
 
 
-		Parse::RecDescent::_trace(q{Trying terminal: ['[']},
-					  Parse::RecDescent::_tracefirst($text),
-					  q{hint},
+		Parse::RecDescent::_trace(q{Trying terminal: ['#']},
+					  Parse::RecDescent::_tracefirst($text),
+					  q{comment},
 					  $tracelevel)
 						if defined $::RD_TRACE;
@@ -5138,5 +4985,5 @@
 		
 
-		unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ s/\A\[//)
+		unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ s/\A\#//)
 		{
 			
@@ -5154,13 +5001,13 @@
 		
 
-		Parse::RecDescent::_trace(q{Trying terminal: [/[^\\]]+/]}, Parse::RecDescent::_tracefirst($text),
-					  q{hint},
+		Parse::RecDescent::_trace(q{Trying terminal: [/.*/]}, Parse::RecDescent::_tracefirst($text),
+					  q{comment},
 					  $tracelevel)
 						if defined $::RD_TRACE;
 		$lastsep = "";
-		$expectation->is(q{/[^\\]]+/})->at($text);
-		
-
-		unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ s/\A(?:[^\]]+)//)
+		$expectation->is(q{/.*/})->at($text);
+		
+
+		unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ s/\A(?:.*)//)
 		{
 			
@@ -5179,55 +5026,8 @@
 		
 
-		Parse::RecDescent::_trace(q{Trying terminal: [']']},
-					  Parse::RecDescent::_tracefirst($text),
-					  q{hint},
-					  $tracelevel)
-						if defined $::RD_TRACE;
-		$lastsep = "";
-		$expectation->is(q{']'})->at($text);
-		
-
-		unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ s/\A\]//)
-		{
-			
-			$expectation->failed();
-			Parse::RecDescent::_trace(qq{<<Didn't match terminal>>},
-						  Parse::RecDescent::_tracefirst($text))
-							if defined $::RD_TRACE;
-			last;
-		}
-		Parse::RecDescent::_trace(q{>>Matched terminal<< (return value: [}
-						. $& . q{])},
-						  Parse::RecDescent::_tracefirst($text))
-							if defined $::RD_TRACE;
-		push @item, $item{__STRING2__}=$&;
-		
-
-		Parse::RecDescent::_trace(q{Trying action},
-					  Parse::RecDescent::_tracefirst($text),
-					  q{hint},
-					  $tracelevel)
-						if defined $::RD_TRACE;
-		
-
-		$_tok = ($_noactions) ? 0 : do { $item[2] };
-		unless (defined $_tok)
-		{
-			Parse::RecDescent::_trace(q{<<Didn't match action>> (return value: [undef])})
-					if defined $::RD_TRACE;
-			last;
-		}
-		Parse::RecDescent::_trace(q{>>Matched action<< (return value: [}
-					  . $_tok . q{])},
-					  Parse::RecDescent::_tracefirst($text))
-						if defined $::RD_TRACE;
-		push @item, $_tok;
-		$item{__ACTION1__}=$_tok;
-		
-
-
-		Parse::RecDescent::_trace(q{>>Matched production: ['[' /[^\\]]+/ ']']<<},
-					  Parse::RecDescent::_tracefirst($text),
-					  q{hint},
+
+		Parse::RecDescent::_trace(q{>>Matched production: ['#' /.*/]<<},
+					  Parse::RecDescent::_tracefirst($text),
+					  q{comment},
 					  $tracelevel)
 						if defined $::RD_TRACE;
@@ -5244,5 +5044,5 @@
 		Parse::RecDescent::_trace(q{<<Didn't match rule>>},
 					 Parse::RecDescent::_tracefirst($_[1]),
-					 q{hint},
+					 q{comment},
 					 $tracelevel)
 					if defined $::RD_TRACE;
@@ -5252,5 +5052,5 @@
 	{
 		Parse::RecDescent::_trace(q{>>Accepted scored production<<}, "",
-					  q{hint},
+					  q{comment},
 					  $tracelevel)
 						if defined $::RD_TRACE;
@@ -5263,10 +5063,10 @@
 		Parse::RecDescent::_trace(q{>>Matched rule<< (return value: [} .
 					  $return . q{])}, "",
-					  q{hint},
+					  q{comment},
 					  $tracelevel);
 		Parse::RecDescent::_trace(q{(consumed: [} .
 					  Parse::RecDescent::_tracemax(substr($_[1],0,-length($text))) . q{])}, 
 					  Parse::RecDescent::_tracefirst($text),
-					  , q{hint},
+					  , q{comment},
 					  $tracelevel)
 	}
@@ -5276,5 +5076,5 @@
 
 # ARGS ARE: ($parser, $text; $repeating, $_noactions, \@args)
-sub Parse::RecDescent::Text::FormBuilder::Parser::type
+sub Parse::RecDescent::Text::FormBuilder::Parser::hint
 {
 	my $thisparser = $_[0];
@@ -5282,9 +5082,9 @@
 	local $tracelevel = ($tracelevel||0)+1;
 	$ERRORS = 0;
-	my $thisrule = $thisparser->{"rules"}{"type"};
-	
-	Parse::RecDescent::_trace(q{Trying rule: [type]},
+	my $thisrule = $thisparser->{"rules"}{"hint"};
+	
+	Parse::RecDescent::_trace(q{Trying rule: [hint]},
 				  Parse::RecDescent::_tracefirst($_[1]),
-				  q{type},
+				  q{hint},
 				  $tracelevel)
 					if defined $::RD_TRACE;
@@ -5318,7 +5118,7 @@
 	{
 		
-		Parse::RecDescent::_trace(q{Trying production: [':' /textarea|text|password|file|checkbox|radio|select|hidden|static/]},
+		Parse::RecDescent::_trace(q{Trying production: ['[' /[^\\]]+/ ']']},
 					  Parse::RecDescent::_tracefirst($_[1]),
-					  q{type},
+					  q{hint},
 					  $tracelevel)
 						if defined $::RD_TRACE;
@@ -5326,12 +5126,12 @@
 		$text = $_[1];
 		my $_savetext;
-		@item = (q{type});
-		%item = (__RULE__ => q{type});
+		@item = (q{hint});
+		%item = (__RULE__ => q{hint});
 		my $repcount = 0;
 
 
-		Parse::RecDescent::_trace(q{Trying terminal: [':']},
-					  Parse::RecDescent::_tracefirst($text),
-					  q{type},
+		Parse::RecDescent::_trace(q{Trying terminal: ['[']},
+					  Parse::RecDescent::_tracefirst($text),
+					  q{hint},
 					  $tracelevel)
 						if defined $::RD_TRACE;
@@ -5340,5 +5140,5 @@
 		
 
-		unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ s/\A\://)
+		unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ s/\A\[//)
 		{
 			
@@ -5356,13 +5156,13 @@
 		
 
-		Parse::RecDescent::_trace(q{Trying terminal: [/textarea|text|password|file|checkbox|radio|select|hidden|static/]}, Parse::RecDescent::_tracefirst($text),
-					  q{type},
+		Parse::RecDescent::_trace(q{Trying terminal: [/[^\\]]+/]}, Parse::RecDescent::_tracefirst($text),
+					  q{hint},
 					  $tracelevel)
 						if defined $::RD_TRACE;
 		$lastsep = "";
-		$expectation->is(q{/textarea|text|password|file|checkbox|radio|select|hidden|static/})->at($text);
-		
-
-		unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ s/\A(?:textarea|text|password|file|checkbox|radio|select|hidden|static)//)
+		$expectation->is(q{/[^\\]]+/})->at($text);
+		
+
+		unless ($text =~ s/\A($skip)/$lastsep=$1 and ""/e and   $text =~ s/\A(?:[^\]]+)//)
 		{
 			
